/* ̧قDoxygenpɏĂ܂B */
/*! \file *********************************************************************
 *
 * \brief XMEGA TWI呕uײ  ̧
 *
 *	̧قXMEGA TWI呕uײނɑ΂̗lXȌ`ԐݒҰp̌^錾
 *	񋓂̒`܂݂܂B
 *
 *	ײނ͖wǂ̊֐Pɐs̺ނŊ֐Ăяo̊Ԑڕׂސ\
 *	炷߁A傫⑬xdvȺނɑ΂ĈӐ}܂Bײނ
 *	XMEGA TWI呕uPʕŎn߂邽߂̑fƎ̖ړIӐ}܂B
 *
 *	傫⑬xdvȺނɂẮA֐ĂяosɂȂ̉p
 *	Ɋ֐e𒼐ڕʂ邱Ƃ܂B
 *
 *
 * $Date: 2011-10-10 13:03:43 $  \n
 *
 * 쌠 (c) 2008, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *****************************************************************************/

#include "atmel_led_device_config.h"
#if defined(ATXMEGA) && defined(TWI)

/* ɏՕ̑傫` */
#define TWIM_WRITE_BUFFER_SIZE	NUM_BYTES+1		//!< ݊ɏՕ̑傫
#define TWIM_READ_BUFFER_SIZE	NUM_BYTES+1		//!< ǂݍ݊ɏՕ̑傫

/*! \brief TWI呕uײލ\
 *
 *  TWI呕u\́BTWIPʕւ̈ʒuwqAɏՕAKvȕϐێ
 */
typedef struct TWI_Master {
	TWI_t *interface;							/*!< ǂȲ̪gւ̈ʒuwq */
	register8_t address;						/*!< ]uڽ */
	register8_t Data[TWIM_READ_BUFFER_SIZE];	/*!< ǂݍް */
	register8_t bytesToWrite;					/*!< ׂ޲Đ */
	register8_t bytesToRead;					/*!< ǂ܂ׂ޲Đ */
	register8_t bytesWritten;					/*!< ꂽ޲Đ */
	register8_t bytesRead;						/*!< ǂ܂ꂽ޲Đ */
	register8_t status;							/*!< ̏ */
	register8_t result;							/*!< ̌ */
}TWI_Master_t;

/* Sϐ */
TWI_Master_t twiMaster;							//!< TWI呕uPʕ

void twi_master_init(TWI_Master_t *twi,
					 TWI_t *module,
					 TWI_MASTER_INTLVL_t intLevel,
					 uint8_t baudRateRegisterSetting);

uint8_t twi_master_write_read(TWI_Master_t *twi,
							  uint8_t address,
							  uint8_t bytesToWrite,
							  uint8_t bytesToRead);
void twi_master_interrupt_handler(TWI_Master_t *twi);
void twi_master_arbitration_lost_bus_error_handler(TWI_Master_t *twi);
void twi_master_write_handler(TWI_Master_t *twi);
void twi_master_read_handler(TWI_Master_t *twi);
void twi_master_transaction_finished(TWI_Master_t *twi, uint8_t result);

/*! \brief TWIPʕ֐B呕uǂݏ荞݋B剞pőS̊荞݂邱ƂYȂłB
 *
 *  \param twi						TWI_Master_t\̎
 *  \param module					TWIPʕgp
 *  \param intLevel					呕u荞
 *  \param baudRateRegisterSetting	ްڰ ڼ޽l
 */
void twi_master_init(TWI_Master_t *twi,
					 TWI_t *module,
					 TWI_MASTER_INTLVL_t intLevel,
					 uint8_t baudRateRegisterSetting)
{
	twi->interface = module;
	twi->interface->MASTER.CTRLA = intLevel |
								   TWI_MASTER_RIEN_bm |
								   TWI_MASTER_WIEN_bm |
								   TWI_MASTER_ENABLE_bm;
	twi->interface->MASTER.BAUD = baudRateRegisterSetting;
	twi->interface->MASTER.STATUS = TWI_MASTER_BUSSTATE_IDLE_gc;

	/* ኄ荞ً */
	PMIC.CTRL |= PMIC_LOLVLEN_bm;
	sei();
}

/*! \brief Atmel LED쓮Pʕ
 *  Iɲ̪ƘAg銄荞݂̐ݒĂт܂B
 */
void atmel_led_drvr_init()
{
	twi_master_init(&twiMaster,
					&TWI_PORT,
					TWI_MASTER_INTLVL_LO_gc,
					TWI_BAUDSETTING);
}

/*! \brief ^ꂽڼ޽ ڽ޲ď
 *  \param slave_address	]u̔zڽBڽƂޯ6`0gp܂(7ޯ ڽ)B
 *  \param REG_ADDR			Atmel LED쓮ڼ޽̱ڽ
 *  \param REG_DATA			Atmel LED쓮ڼ޽֏ް
 *  \retval true			Jnłꍇ
 *  \retval false			JnłȂꍇ
 */
uint8_t atmel_led_drvr_writeregister(uint8_t slave_address, uint8_t REG_ADDR, uint8_t REG_DATA)
{
	uint8_t result;
	twiMaster.Data[0] = REG_ADDR;
	twiMaster.Data[1] = REG_DATA;

	result = twi_master_write_read(&twiMaster,
								   slave_address,
								   2,
								   0);
	/* ܂őҋ@ */
	while (twiMaster.status != TWIM_STATUS_READY) {}
	return result;
}

/*! \brief ^ꂽڼ޽ ڽŎn܂ڼ޽ ޲Ĕz
 *  \param slave_address	]u̔zڽBڽƂޯ6`0gp܂(7ޯ ڽ)B
 *  \param REG_ADDR			݂JnAtmel LED쓮ڼ޽̱ڽ
 *  \param Data				Atmel LED쓮ڼ޽֏ްzւ̈ʒuwq
 *  \param count			޲Đ
 *  \retval true			Jnłꍇ
 *  \retval false			JnłȂꍇ
 */
unsigned char atmel_led_drvr_writearray(unsigned char slave_address, unsigned char REG_ADDR, unsigned char* Data, unsigned char count)
{
	uint8_t result;
	uint8_t index = 1;
	twiMaster.Data[0] = REG_ADDR;

	for(index = 1;index <= count;index++)
	{
		twiMaster.Data[index] = Data[index-1];
	}

	result = twi_master_write_read(&twiMaster,
								   slave_address,
								   count+1,
								   0);
	/* ܂őҋ@ */
	while (twiMaster.status != TWIM_STATUS_READY) {}
	return result;
}

/*! \brief ^ꂽڼ޽ ڽ޲ēǂݍ
 *  \param slave_address	]u̔zڽBڽƂޯ6`0gp܂(7ޯ ڽ)B
 *  \param REG_ADDR			Atmel LED쓮ڼ޽̱ڽ
 *  \param receivedData		i[Mް̏ꏊւ̈ʒuwq
 *  \retval true			Jnłꍇ
 *  \retval false			JnłȂꍇ
 */		
uint8_t atmel_led_drvr_readregister(uint8_t slave_address, uint8_t REG_ADDR, uint8_t *receivedData)
{
	uint8_t result;
	twiMaster.Data[0] = REG_ADDR;
	result = twi_master_write_read(&twiMaster,
								   slave_address,
								   1,
								   1);
	/* ܂őҋ@ */
	while (twiMaster.status != TWIM_STATUS_READY) {}

	*receivedData = twiMaster.Data[0];
	return result;
}

/*! \brief ^ꂽڼ޽ ڽŎn܂ڼ޽ ޲Ĕzǂݍ
 *  \param slave_address	]u̔zڽBڽƂޯ6`0gp܂(7ޯ ڽ)B
 *  \param REG_ADDR			ǂݍ݂JnAtmel LED쓮ڼ޽̱ڽ
 *  \param Data				Atmel LED쓮ڼ޽̓ǂݍݒli[ްzւ̈ʒuwq
 *  \param count			ǂݍ޲Đ
 *  \retval true			Jnłꍇ
 *  \retval false			JnłȂꍇ
 */
unsigned char atmel_led_drvr_readarray(unsigned char slave_address, unsigned char REG_ADDR, unsigned char* Data, unsigned char count)
{
	uint8_t result;
	uint8_t index;
	twiMaster.Data[0] = REG_ADDR;
	result = twi_master_write_read(&twiMaster,
								   slave_address,
								   1,
								   count);
	/* ܂őҋ@ */
	while (twiMaster.status != TWIM_STATUS_READY) {}

	for(index = 0; index < count; index++)
	{
		Data[index] = twiMaster.Data[index];
	}
	return result;
}

/*! \brief ̊֐TWI呕uǂݏłB֐1̏TWI]u޲
 *  Ă̓ǂݏɎgp邱Ƃł܂B
 *
 *  \param twi				TWI_Master_t\̎
 *  \param address			]uڽ
 *  \param bytesToWrite		޲Đ
 *  \param bytesToRead		ǂ޲Đ
 *
 *  \retval true			Jnłꍇ
 *  \retval false			JnłȂꍇ
 */
uint8_t twi_master_write_read(TWI_Master_t *twi,
							  uint8_t address,
							  uint8_t bytesToWrite,
							  uint8_t bytesToRead)
{
	/* Ұ */
	if (bytesToWrite > TWIM_WRITE_BUFFER_SIZE) {
		return 0;
	}
	if (bytesToRead > TWIM_READ_BUFFER_SIZE) {
		return 0;
	}

	/* ޽Ȃ珈Jn */
	if (twi->status == TWIM_STATUS_READY) {

		twi->status = TWIM_STATUS_BUSY;
		twi->result = TWIM_RESULT_UNKNOWN;

		twi->address = address<<1;

		twi->bytesToWrite = bytesToWrite;
		twi->bytesToRead = bytesToRead;
		twi->bytesWritten = 0;
		twi->bytesRead = 0;

		/* ݖ߂ȂAJn+ڽ+R/W=0𑗏o */
		if (twi->bytesToWrite > 0) {
			uint8_t writeAddress = twi->address & ~0x01;
			twi->interface->MASTER.ADDR = writeAddress;
		}

		/* ǂݍݖ߂ȂAJn+ڽ+R/W=1𑗏o */
		else if (twi->bytesToRead > 0) {
			uint8_t readAddress = twi->address | 0x01;
			twi->interface->MASTER.ADDR = readAddress;
		}
		return 1;
	} else {
		return 0;
	}
}

/*! \brief TWI呕u荞ݏٰ݁B݂̏Ԃ𒲂ׂēK؂ȏĂт܂B
 *
 *  \param twi		TWI_Master_t\̎
 */
void twi_master_interrupt_handler(TWI_Master_t *twi)
{
	uint8_t currentStatus = twi->interface->MASTER.STATUS;

	if ((currentStatus & TWI_MASTER_ARBLOST_bm) ||	/* sނ޽ُŁA */
		(currentStatus & TWI_MASTER_BUSERR_bm)) {

		twi_master_arbitration_lost_bus_error_handler(twi);
	}

	else if (currentStatus & TWI_MASTER_WIF_bm) {	/* 呕u݊荞݂ŁA */
		twi_master_write_handler(twi);
	}

	else if (currentStatus & TWI_MASTER_RIF_bm) {	/* 呕uǂݍ݊荞݂ŁA */
		twi_master_read_handler(twi);
	}

	else {											/* \ʏԂŁA */
		twi_master_transaction_finished(twi, TWIM_RESULT_FAIL);
	}
}

/*! \brief TWI呕usނ޽ُ튄荞ݏBsނ޽ُɑ΂TWI
 *
 *  \param twi		TWI_Master_t\̎
 */
void twi_master_arbitration_lost_bus_error_handler(TWI_Master_t *twi)
{
	uint8_t currentStatus = twi->interface->MASTER.STATUS;

	if (currentStatus & TWI_MASTER_BUSERR_bm) {		/* ޽ȏŁA */
		twi->result = TWIM_RESULT_BUS_ERROR;
	}
	else {											/* sނŁA */
		twi->result = TWIM_RESULT_ARBITRATION_LOST;
	}

	twi->interface->MASTER.STATUS = currentStatus | TWI_MASTER_ARBLOST_bm;	/* 荞׸މ */

	twi->status = TWIM_STATUS_READY;
}

/*! \brief TWI呕u݊荞ݏBTWI(呕u)(N)ACKւ̉
 *
 *  \param twi		TWI_Master_t\̎
 */
void twi_master_write_handler(TWI_Master_t *twi)
{
	/* ׂ߲̌x̂𒲂ׂꍇɎgpǏϐ */
	uint8_t bytesToWrite  = twi->bytesToWrite;
	uint8_t bytesToRead   = twi->bytesToRead;

	if (twi->interface->MASTER.STATUS & TWI_MASTER_RXACK_bm) {	/* ]uɂĔے艞(NACK)ꍇɒPʏ */
		twi->interface->MASTER.CTRLC = TWI_MASTER_CMD_STOP_gc;
		twi->result = TWIM_RESULT_NACK_RECEIVED;
		twi->status = TWIM_STATUS_READY;
	}

	else if (twi->bytesWritten < bytesToWrite) {				/* ޲ĂƗLꍇްo */
		uint8_t data = twi->Data[twi->bytesWritten];
		twi->interface->MASTER.DATA = data;
		++twi->bytesWritten;
	}

	else if (twi->bytesRead < bytesToRead) {					/* ޲ēǂݍ݂ȂAđJn+ڽ+'R/W=1'𑗏o */
		uint8_t readAddress = twi->address | 0x01;
		twi->interface->MASTER.ADDR = readAddress;
	}

	else {														/* PʏIŁA~oAOKݒ */
		twi->interface->MASTER.CTRLC = TWI_MASTER_CMD_STOP_gc;
		twi_master_transaction_finished(twi, TWIM_RESULT_OK);
	}
}

/*! \brief TWI呕uǂݍ݊荞ݏBTWI]u޲ēǂݍ݂呕uǂݍ݊荞ݏłB
 *
 *  \param twi		TWI_Master_t\̎
 */
void twi_master_read_handler(TWI_Master_t *twi)
{
	if (twi->bytesRead < TWIM_READ_BUFFER_SIZE) {	/* o޲ėLŁAް擾 */
		uint8_t data = twi->interface->MASTER.DATA;
		twi->Data[twi->bytesRead] = data;
		twi->bytesRead++;
	}

	else {											/* ɏՕŒ~sAɏՕԐݒ */
		twi->interface->MASTER.CTRLC = TWI_MASTER_CMD_STOP_gc;
		twi_master_transaction_finished(twi, TWIM_RESULT_BUFFER_OVERFLOW);
	}

	uint8_t bytesToRead = twi->bytesToRead;			/* ׂ߲̌x̂𒲂ׂꍇɎgpǏϐ */

	if (twi->bytesRead < bytesToRead) {				/* ǂݍ޲ĂƗLȂAAVK𔭍s޲ēǂݍ݊Jn */
		twi->interface->MASTER.CTRLC = TWI_MASTER_CMD_RECVTRANS_gc;
	}

	else {											/* PʏIŁANACKƒ~𔭍s */
		twi->interface->MASTER.CTRLC = TWI_MASTER_ACKACT_bm |
									   TWI_MASTER_CMD_STOP_gc;
		twi_master_transaction_finished(twi, TWIM_RESULT_OK);
	}
}

/*! \brief TWIPʏIBVPʏ̂߂ɒPʕ
 *
 *  \param twi		TWI_Master_t\̎
 *  \param result	̌
 */
void twi_master_transaction_finished(TWI_Master_t *twi, uint8_t result)
{
	twi->result = result;
	twi->status = TWIM_STATUS_READY;
}

/*! \brief TWIC呕u荞޸ */
ISR(TWI_INT_VECTOR)
{
	twi_master_interrupt_handler(&twiMaster);
}
#endif
