/* ̧قDoxygenpɏĂ܂B */
/*! \file *********************************************************************
 *
 * \brief TINY SPI呕uUSIײ  ̧
 *
 *	̧قtiny SPI(USI)呕uײނɑ΂̗lXȌ`ԐݒҰp̌^
 *	Ɨ񋓂̒`܂݂܂B
 *
 *	ײނ͖wǂ̊֐Pɐs̺ނŊ֐Ăяo̊Ԑڕׂސ\
 *	炷߁A傫⑬xdvȺނɑ΂ĈӐ}܂Bײނtiny
 *	 SPI(USI)呕uPʕŎn߂邽߂̑fƎ̖ړIӐ}܂B
 *
 *	傫⑬xdvȺނɂẮA֐ĂяosɂȂ̉p
 *	Ɋ֐e𒼐ڕʂ邱Ƃ܂B
 *
 *
 * $Date: 2011-10-10 13:03:43 $  \n
 *
 * 쌠 (c) 2008, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *****************************************************************************/

#include "atmel_led_device_config.h"

#if defined(TINYAVR) && defined(SPI_USI)

/*  ޯĐݒɕϊ镪l */
#if TC0_PRESCALER_VALUE == 1
	#define TC0_PS_SETTING (1<<CS00)
#elif TC0_PRESCALER_VALUE == 8
	#define TC0_PS_SETTING (1<<CS01)
#elif TC0_PRESCALER_VALUE == 64
	#define TC0_PS_SETTING (1<<CS01)|(1<<CS00)
#elif TC0_PRESCALER_VALUE == 256
	#define TC0_PS_SETTING (1<<CS02)
#elif TC0_PRESCALER_VALUE == 1024
	#define TC0_PS_SETTING (1<<CS02)|(1<<CS00)
#else
	#error Invalid T/C0 prescaler setting.
#endif

/*! \brief ްڼ޽ɏՕ
 *
 *  ė޲Ă͎̓]܂ł޲ĂɊi[܂B޲Ă޲
 *  ̓]Oɓǂ܂Ȃ΂Ȃ炸Aݒl㏑{SPIPʕSPI
 *  ް ڼ޽Ɠ悤Ɏgp邱Ƃł܂B
 */
volatile unsigned char storedUSIDR;

volatile struct usidriverStatus_t spiX_status;		//!< ײޏޯ

/*! \brief /0rv荞ݏ
 *
 *  ̊荞ݏ͎呕uް]Ă鎞ɂ܂B
 *  USIۯ ݂ݐ؂ւAA2̊荞݂͸ۯ ݂USIvɑ
 *  1̸ۯɋA܂B
 */
ISR(TIMER0_COMPA_vect)
{
	USICR |= (1<<USITC);	// ۯo݌ݐ؂ւ
}

/*! \brief USIvꊄ荞ݏ
 *
 *  ͎̏呕uȂΔrv荞݂֎~܂BUSIvꎞA
 *  ޲Ă]Av~Ȃ΂Ȃ܂B
 *  SĂ̓ɑ΂USIDRei[׸ނXV܂B
 */
ISR (USI_OVF_vect)
{
	// 呕u͍XȂUSIvۯh߂ɍrv荞݂֎~Ȃ
	// ΂Ȃ܂B
	if( spiX_status.masterMode == 1 ) {
		TIMSK &= ~(1<<OCIE0A);
	}

	// ׸ލXVUSIv
	USISR = (1<<USIOIF);
	spiX_status.transferComplete = 1;

	storedUSIDR = USIDR;	// ̓]ł̏㏑h߂UDIDRɏՕɕ
}

/*! \brief USISPI呕uƂď
 *
 *  ̊֐͑SĂݕƒPʕ`Ԑݒ\ݒ肵܂BŏɁA܂͏]
 *  u呕u֕ύX鎞ɂ̊֐gpĂB
 *  i[ꂽUSIDRl邱ƂɒӂĂB
 *
 *  \param spi_mode		KvƂSPIʁA0܂1łȂ΂Ȃ܂B
 */
void spiX_initmaster( char spi_mode )
{

	// ߰ĕ`Ԑݒ
	USI_DIR_REG |= (1<<USI_DATAOUT_PIN) | (1<<USI_CLOCK_PIN) | (1<< CSB_PIN);	// o
	USI_DIR_REG &= ~(1<<USI_DATAIN_PIN);	// 
	USI_OUT_REG |= (1<<USI_DATAIN_PIN);		// ٱߋ
	USI_OUT_REG |= (1<<CSB_PIN);

	// USIꊄ荞݂Ƌ3呕uɌ`Ԑݒ
	USICR = (1<<USIOIE) | (1<<USIWM0) |
			(1<<USICS1) | (spi_mode<<USICS0) |
			(1<<USICLK);

	TCCR0A = (1<<WGM01);					// T/C0CTC싖
	TCCR0B = TC0_PS_SETTING;				// Ouݒ
	OCR0A = TC0_COMPARE_VALUE;				// rڼ޽

	// ײޏڼ޽
	spiX_status.masterMode       = 1;
	spiX_status.transferComplete = 0;
	spiX_status.writeCollision   = 0;

	storedUSIDR = 0;
}

/*! \brief Atmel LED쓮Pʕ
 *  Iɲ̪ƘAg銄荞ݐݒĂт܂B
 */
void atmel_led_drvr_init()
{
	spiX_initmaster(0);		// 呕uƂSPIײޏ
	sei();
}

/*! \brief ^ꂽڼ޽ ڽ޲ď
 *  \param slave_address	]u̔zڽBڽƂޯ7`1gp܂(7ޯ ڽ)B
 *  \param REG_ADDR			Atmel LED쓮ڼ޽̱ڽ
 *  \param REG_DATA			Atmel LED쓮ڼ޽֏ް
 *  \retval true			Jnłꍇ
 *  \retval false			JnłȂꍇ
 */				   
unsigned char atmel_led_drvr_writeregister(unsigned char slave_address, unsigned char REG_ADDR, unsigned char REG_DATA)
{
	unsigned char success = 0x0;

	USI_OUT_REG &= ~(1<<CSB_PIN);					// CSB=Low

	success = spiX_put( slave_address | 0x01 );		// 
	spiX_wait();

	if(success)
	{
		success = spiX_put( REG_ADDR );
		spiX_wait();
		if(success)
		{
			success = spiX_put( REG_DATA );
			spiX_wait();
		}
	}

	USI_OUT_REG |= (1<<CSB_PIN);					// CSB=High

	// LED쓮̪ؾĂ邽߂Ɍv
	success = spiX_put( 0x00 );
	spiX_wait();

	delay_us(20);

	return success;
}

/*! \brief ^ꂽڼ޽ ڽŎn܂ڼ޽ ޲Ĕz
 *  \param slave_address	]u̔zڽBڽƂޯ7`1gp܂(7ޯ ڽ)B
 *  \param REG_ADDR			݂JnAtmel LED쓮ڼ޽̱ڽ
 *  \param Data				Atmel LED쓮ڼ޽֏ްzւ̈ʒuwq
 *  \param count			޲Đ
 *  \retval true			Jnłꍇ
 *  \retval false			JnłȂꍇ
 */
unsigned char atmel_led_drvr_writearray(unsigned char slave_address, unsigned char REG_ADDR, unsigned char* Data, unsigned char count)
{
	unsigned char success = 0x0;
	unsigned char index = 0;

	USI_OUT_REG &= ~(1<<CSB_PIN);					// CSB=Low

	success = spiX_put( slave_address | 0x01 );		// 
	spiX_wait();

	if(success)
	{
		success = spiX_put( REG_ADDR );
		spiX_wait();
		if(success)
		{
			while((success == 1) && (index < count))
			{
				success = spiX_put( Data[index++] );
				spiX_wait();
			}
		}
	}

	USI_OUT_REG |= (1<<CSB_PIN);					// CSB=High

	// LED쓮̪ؾĂ邽߂Ɍv
	success = spiX_put( 0x00 );
	spiX_wait();

	delay_us(20);

	return success;
}

/*! \brief ^ꂽڼ޽ ڽ޲Ăǂݍ
 *  \param slave_address	]u̔zڽBڽƂޯ7`1gp܂(7ޯ ڽ)B
 *  \param REG_ADDR			Atmel LED쓮ڼ޽̱ڽ
 *  \param receivedData		i[Mް̏ꏊւ̈ʒuwq
 *  \retval true			Jnłꍇ
 *  \retval false			JnłȂꍇ
 */		

unsigned char atmel_led_drvr_readregister(unsigned char slave_address, unsigned char REG_ADDR, unsigned char* receivedData)
{
	unsigned char success = 0x0;

	USI_OUT_REG &= ~(1<<CSB_PIN);					// CSB=Low

	success = spiX_put( slave_address | 0x00 );		// ǂݍ
	spiX_wait();
	if(success)
	{
		success = spiX_put( REG_ADDR );
		spiX_wait();
		if(success)
		{
			success = spiX_put( 0X00 );				// Atmel LED쓮ްM邽߂̋U
			spiX_wait();
			*receivedData = spiX_get();
		}
		
	}

	USI_OUT_REG |= (1<<CSB_PIN);					// CSB=High

	// LED쓮̪ؾĂ邽߂Ɍv
	success = spiX_put( 0x00 );
	spiX_wait();

	delay_us(20);

	return success;
}

/*! \brief ^ꂽڼ޽ ڽŎn܂ڼ޽ ޲Ĕzǂݍ
 *  \param slave_address	]u̔zڽBڽƂޯ7`1gp܂(7ޯ ڽ)B
 *  \param REG_ADDR			ǂݍ݂JnAtmel LED쓮ڼ޽̱ڽ
 *  \param Data				Atmel LED쓮ڼ޽̓ǂݍݒli[ްzւ̈ʒuwq
 *  \param count			ǂݍ޲Đ
 *  \retval true			Jnłꍇ
 *  \retval false			JnłȂꍇ
 */
unsigned char atmel_led_drvr_readarray(unsigned char slave_address, unsigned char REG_ADDR, unsigned char* Data, unsigned char count)
{
	unsigned char success = 0x0;
	unsigned char index = 0;

	USI_OUT_REG &= ~(1<<CSB_PIN);					// CSB=Low

	success = spiX_put( slave_address | 0x00 );		// ǂݍ
	spiX_wait();
	if(success)
	{
		success = spiX_put( REG_ADDR );
		spiX_wait();
		if(success)
		{
			while((success == 1) && (index < count))
			{
				success = spiX_put( 0x00 );			// Atmel LED쓮ްM邽߂̋U
				spiX_wait();
				Data[index++] = spiX_get();
			}
		}
	}

	USI_OUT_REG |= (1<<CSB_PIN);					// CSB=High

	// LED쓮̪ؾĂ邽߂Ɍv
	success = spiX_put( 0x00 );
	spiX_wait();

	delay_us(20);

	return success;
}

/*! \brief ޽1޲ďo
 *
 *  {SPIPʕSPDRڼ޽ɏ悤ɂ̊֐gpĂB呕u
 *  ł̂̊֐Ăяo͓]JnA]uł͎呕uɂĎn߂
 *  鎟̓]ɑ΂޲Ă܂B]is̏ꍇÅ֐͏
 *  Փ׸ނݒ肵ް ڼ޽̕ύXȂɖ߂܂B
 *
 *  \returns	ݏՓ˔0AȂ1
 */
char spiX_put( unsigned char val )
{

	if( (USISR & 0x0F) != 0 ) {				// ]isAASUIv=0AisŁA
		spiX_status.writeCollision = 1;		// ݏՓ˂
		return 0;
	}

	// ׸ލď
	spiX_status.transferComplete = 0;
	spiX_status.writeCollision = 0;

	USIDR = val;							// USIް ڼ޽ްzu

	// 呕u͍rv荞݂ׂłB
	if( spiX_status.masterMode == 1 ) {
		TIFR |= (1<<OCF0A);					// rv荞ݗv׸މ
		TIMSK |= (1<<OCIE0A);				// rv荞݋
	}

	if( spiX_status.writeCollision == 0 ) return 1;
	return 0;
}

/*! \brief ޽1޲Ď擾
 *
 *  ̊֐͒OɊi[ꂽUSIDRlԂłB]׸ނ͌܂
 *  B{SPIPʕSPDRڼ޽ǂނ悤ɂ̊֐gpĂB
 */
unsigned char spiX_get()
{
	return storedUSIDR;
}

/*! \brief ]ҋ@
 *
 *  ̊֐͓]׸ނݒ肳܂ő҂܂B{SPI荞׸ނ҂
 *  悤ɂ̊֐gpĂB
 */
void spiX_wait()
{
	do {} while( spiX_status.transferComplete == 0 );
}

#endif

// ُ̧I[
